
%%%%%%%% Input sounds%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [norm_out] = interpspeech(vowel1,vowel2,Fs,source,endmarker,...
    framesynthesis,numoverlaps,windowsynthesis,typemovement,typeanalysis)

sig = source; 


att  = linspace(0,1,(Fs/1000)*5);

dec  = linspace(1,0,(Fs/1000)*5);
sus  = ones(length(sig)-length(att)-length(dec),1)';
env2 = [ att sus dec]';

sig  = sig.*env2;

framelen = framesynthesis; 

hop      = floor(framelen/numoverlaps);
hopsize  = floor(framelen-(framelen/numoverlaps)); 

ninterp = floor(length(sig)/floor(framelen-hopsize));
nframes  = ninterp;





added    = framelen; 

w        = hanning(framelen);

wmark    = hanning(endmarker);
wmark2   = triang(endmarker);
wrect    = rectwin(hop);


%initializations
sig = [zeros(added,1);sig;zeros(added,1)]; %add zeros at the beginning to not
%an index equal to zero when recontrsucting the signal

out = zeros(length(sig),1);


zi = zeros(nframes,10);

if typeanalysis==2
den1= lpc(vowel1.*wmark2,10);


rootspoles1 = roots(den1);  

den2= lpc(vowel2.*wmark2,10);


rootspoles2 = roots(den2);




%pole_extraction coordinates sound1

values_poles1 = rootspoles1(find(imag(rootspoles1)>=0));

rp1 = real(values_poles1(1,:));
rp2 = real(values_poles1(2,:));
rp3 = real(values_poles1(3,:));
rp4 = real(values_poles1(4,:));
rp5 = real(values_poles1(5,:));

ip1 = imag(values_poles1(1,:));
ip2 = imag(values_poles1(2,:));
ip3 = imag(values_poles1(3,:));
ip4 = imag(values_poles1(4,:));
ip5 = imag(values_poles1(5,:));

%pole_extraction coordinates sound2

values_poles2 = rootspoles2(find(imag(rootspoles2)>=0));

rp1b = real(values_poles2(1,:));
rp2b = real(values_poles2(2,:));
rp3b = real(values_poles2(3,:));
rp4b = real(values_poles2(4,:));
rp5b = real(values_poles2(5,:));

ip1b = imag(values_poles2(1,:));
ip2b = imag(values_poles2(2,:));
ip3b = imag(values_poles2(3,:));
ip4b = imag(values_poles2(4,:));
ip5b = imag(values_poles2(5,:));


if typemovement ==2


[thetap1,rhop1] = cart2pol(rp1,ip1);

[thetap1b,rhop1b] = cart2pol(rp1b,ip1b);

interpthetap1  = linspace(thetap1,thetap1b,ninterp);
interprhop1    = linspace(rhop1,rhop1b,ninterp);


[realpart1,imapart1] = pol2cart(interpthetap1,interprhop1);
imapart1 = imapart1*i;

%realpart1 = linspace(rp1,rp1b,ninterp);
%imapart1 = linspace(ip1*i,ip1b*i,ninterp);
%p2
[thetap2,rhop2] = cart2pol(rp2,ip2);

[thetap2b,rhop2b] = cart2pol(rp2b,ip2b);

interpthetap2  = linspace(thetap2,thetap2b,ninterp);
interprhop2    = linspace(rhop2,rhop2b,ninterp);


[realpart2,imapart2] = pol2cart(interpthetap2,interprhop2);
imapart2 = imapart2*i;

%realpart2 = linspace(rp2,rp2b,ninterp);
%imapart2 = linspace(ip2*i,ip2b*i,ninterp);
%p3

[thetap3,rhop3] = cart2pol(rp3,ip3);

[thetap3b,rhop3b] = cart2pol(rp3b,ip3b);

interpthetap3  = linspace(thetap3,thetap3b,ninterp);
interprhop3    = linspace(rhop3,rhop3b,ninterp);


[realpart3,imapart3] = pol2cart(interpthetap3,interprhop3);
imapart3 = imapart3*i;

%realpart3 = linspace(rp3,rp3b,ninterp);
%imapart3 = linspace(ip3*i,ip3b*i,ninterp);
%p4
[thetap4,rhop4] = cart2pol(rp4,ip4);

[thetap4b,rhop4b] = cart2pol(rp4b,ip4b);

interpthetap4  = linspace(thetap4,thetap4b,ninterp);
interprhop4    = linspace(rhop4,rhop4b,ninterp);


[realpart4,imapart4] = pol2cart(interpthetap4,interprhop4);
imapart4 = imapart4*i;

%realpart4 = linspace(rp4,rp4b,ninterp);
%imapart4 = linspace(ip4*i,ip4b*i,ninterp);
%p5
[thetap5,rhop5] = cart2pol(rp5,ip5);

[thetap5b,rhop5b] = cart2pol(rp5b,ip5b);

interpthetap5 = linspace(thetap5,thetap5b,ninterp);
interprhop5    = linspace(rhop5,rhop5b,ninterp);


[realpart5,imapart5] = pol2cart(interpthetap5,interprhop5);
imapart5 = imapart5*i;

%realpart5 = linspace(rp5,rp5b,ninterp);
%imapart5 = linspace(ip5*i,ip5b*i,ninterp);
%................................................................   
else
%Zeros  input values section......................................

%Pole  input values section......................................
%p1
realpart1 = linspace(rp1,rp1b,ninterp);
imapart1 = linspace(ip1*i,ip1b*i,ninterp);
%p2
realpart2 = linspace(rp2,rp2b,ninterp);
imapart2 = linspace(ip2*i,ip2b*i,ninterp);
%p3
realpart3 = linspace(rp3,rp3b,ninterp);
imapart3 = linspace(ip3*i,ip3b*i,ninterp);
%p4
realpart4 = linspace(rp4,rp4b,ninterp);
imapart4 = linspace(ip4*i,ip4b*i,ninterp);
%p5
realpart5 = linspace(rp5,rp5b,ninterp);
imapart5 = linspace(ip5*i,ip5b*i,ninterp);
end
%................................................................

%p1 conj
pole1 = realpart1+imapart1;
conju1=  realpart1-imapart1;

a1= -(pole1+conju1);
a2= (pole1.*conju1);

a0= ones(size(a2)); %after a2 for intialization

%p2 conj

pole2 = realpart2+imapart2;
conju2=  realpart2-imapart2;

a12= -(pole2+conju2);

a22= (pole2.*conju2);

a02= ones(size(a22)); %after a2 for intialization

coeffa2 =[a02;a12;a22]';

%p3 conj
pole3 = realpart3+imapart3;
conju3=  realpart3-imapart3;

a13= -(pole3+conju3);

a23= (pole3.*conju3);

a03= ones(size(a23)); %after a2 for intialization

coeffa3 =[a03;a13;a23]'; 

%p4 conj
pole4 = realpart4+imapart4;
conju4=  realpart4-imapart4;

a14= -(pole4+conju4); 

a24= (pole4.*conju4);

a04= ones(size(a24)); %after a2 for intialization

coeffa4 =[a04;a14;a24]';


%p4 conj
pole5 = realpart5+imapart5;
conju5=  realpart5-imapart5;

a15= -(pole5+conju5);

a25= (pole5.*conju5);

a05= ones(size(a25)); %after a2 for intialization

coeffa5 =[a05;a15;a25]';

%it uses ; to create multiple rows and ' to rotate
%the matrix for easier comparison
%---------------------------------------
%P1*P2
%calculates coefficients first two poles
a1p12 = (a0.*a12)+(a1.*a02);

a2p12 = (a0.*a22)+(a1.*a12)+(a2.*a02);

a3p12 = (a1.*a22)+(a2.*a12);

a4p12 = (a2.*a22);

a0p12 =ones(size(a2p12));
%P1*P2*P3
%adding third pole
a1p123 = (a0p12.*a13)+(a1p12.*a03);

a2p123 = (a0p12.*a23)+(a1p12.*a13)+(a2p12.*a03);

a3p123 = (a1p12.*a23)+(a2p12.*a13)+(a3p12.*a03);

a4p123 = (a4p12.*a03)+(a3p12.*a13)+(a2p12.*a23);

a5p123 = (a4p12.*a13)+(a3p12.*a23);

a6p123 = (a4p12.*a23);

a0p123 =ones(size(a1p123));

%P1*P2*P3*P4
%adding fourth pole
a1p1234  = (a1p123.*a04)+(a0p123.*a14);

a2p1234  = (a0p123.*a24)+(a1p123.*a14)+(a2p123.*a04);

a3p1234  = (a1p123.*a24)+(a2p123.*a14)+(a3p123.*a04);

a4p1234 = (a2p123.*a24)+(a3p123.*a14)+(a4p123.*a04);

a5p1234  = (a3p123.*a24)+(a4p123.*a14)+(a5p123.*a04);

a6p1234  = (a4p123.*a24)+(a5p123.*a14)+(a6p123.*a04);

a7p1234  = (a5p123.*a24)+(a6p123.*a14);

a8p1234  = (a6p123.*a24);

a0p1234  =ones(size(a2p1234));

%P1*P2*P3*P4*P5
a1ptot   = (a0p1234.*a15)+(a1p1234.*a05);
a2ptot   = (a0p1234.*a25)+(a1p1234.*a15)+(a2p1234.*a05);
a3ptot   = (a1p1234.*a25)+(a2p1234.*a15)+(a3p1234.*a05);
a4ptot   = (a2p1234.*a25)+(a3p1234.*a15)+(a4p1234.*a05);
a5ptot   = (a3p1234.*a25)+(a4p1234.*a15)+(a5p1234.*a05);
a6ptot   = (a4p1234.*a25)+(a5p1234.*a15)+(a6p1234.*a05);
a7ptot   = (a5p1234.*a25)+(a6p1234.*a15)+(a7p1234.*a05);
a8ptot   = (a6p1234.*a25)+(a7p1234.*a15)+(a8p1234.*a05);
a9ptot   = (a7p1234.*a25)+(a8p1234.*a15);
a10ptot  = (a8p1234.*a25);
a0ptot   = ones(size(a2ptot));


coeffap12 = [a0p12;a1p12;a2p12;a3p12;a4p12]';
coeffap123 = [a0p123;a1p123;a2p123;a3p123;a4p123;a5p123;a6p123]';
coeffap1234 = [a0p1234;a1p1234;a2p1234;a3p1234;a4p1234;a5p1234;a6p1234;...
    a7p1234;a8p1234]';

coeffaptot = [a0ptot;a1ptot;a2ptot;a3ptot;a4ptot;a5ptot;a6ptot;a7ptot;...
    a8ptot;a9ptot;a10ptot]';

%.....................................................................

figure(3)
  for n = 1:ninterp
 zplane(1,coeffaptot(n,:)); 
 pause(0.00012)   
  end
  

if windowsynthesis==2
for j=1:nframes
    k = (framelen-hopsize)*j;
    
   frame  = filter(1,coeffaptot(j,:)',sig(k:k+framelen-1)); 

    out(k:k+framelen-1)=out(k:k+framelen-1)+frame.*w;
    
end
gainnoclip = 0.9;

norm_out = out/max(abs(out)).*gainnoclip;
pause(0.6)
soundsc(norm_out,Fs)    
else
 for j=1:nframes
    k = (framelen-hopsize)*j;




[frame,zf] = filter(1,coeffaptot(j,:)',sig(k:k+hop-1),zi(j,:));
 zi(j+1,:)= zf;  

monitor(j,:)= k;

    out(k:k+hop-1)=out(k:k+hop-1)+(frame.*wrect);
    
end
gainnoclip = 0.9;

norm_out = out/max(abs(out)).*gainnoclip;
pause(0.6)
soundsc(norm_out,Fs)

end

else

%%%%%%%%%% Prony analysis section %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


[num1,den1]= prony(vowel1.*wmark2,6,10);

rootszeros1 = roots(num1);
rootspoles1 = roots(den1);   

[num2,den2]= prony(vowel2.*wmark2,6,10);

rootszeros2 = roots(num2);
rootspoles2 = roots(den2);



%zero_extraction coordinates sound1


values_zeros1 = rootszeros1(find(imag(rootszeros1)>=0));
rz1 = real(values_zeros1(1,:));
rz2 = real(values_zeros1(2,:));
rz3 = real(values_zeros1(3,:));


iz1 = imag(values_zeros1(1,:));
iz2 = imag(values_zeros1(2,:));
iz3 = imag(values_zeros1(3,:));

%pole_extraction coordinates sound1

values_poles1 = rootspoles1(find(imag(rootspoles1)>=0));

rp1 = real(values_poles1(1,:));
rp2 = real(values_poles1(2,:));
rp3 = real(values_poles1(3,:));
rp4 = real(values_poles1(4,:));
rp5 = real(values_poles1(5,:));

ip1 = imag(values_poles1(1,:));
ip2 = imag(values_poles1(2,:));
ip3 = imag(values_poles1(3,:));
ip4 = imag(values_poles1(4,:));
ip5 = imag(values_poles1(5,:));

%pole_extraction coordinates sound2

values_poles2 = rootspoles2(find(imag(rootspoles2)>=0));

rp1b = real(values_poles2(1,:));
rp2b = real(values_poles2(2,:));
rp3b = real(values_poles2(3,:));
rp4b = real(values_poles2(4,:));
rp5b = real(values_poles2(5,:));

ip1b = imag(values_poles2(1,:));
ip2b = imag(values_poles2(2,:));
ip3b = imag(values_poles2(3,:));
ip4b = imag(values_poles2(4,:));
ip5b = imag(values_poles2(5,:));

%zero_extraction coordinates sound2

values_zeros2 = rootszeros2(find(imag(rootszeros2)>=0));
rz1b = real(values_zeros2(1,:));
rz2b = real(values_zeros2(2,:));
rz3b = real(values_zeros2(3,:));

iz1b = imag(values_zeros2(1,:));
iz2b = imag(values_zeros2(2,:));
iz3b = imag(values_zeros2(3,:));
if typemovement ==2
 %Zeros  input values section......................................


[thetaz1,rhoz1] = cart2pol(rz1,iz1);

[thetaz1b,rhoz1b] = cart2pol(rz1b,iz1b);

interpthetaz1  = linspace(thetaz1,thetaz1b,ninterp);
interprhoz1    = linspace(rhoz1,rhoz1b,ninterp);


[realpartz1,imapartz1] = pol2cart(interpthetaz1,interprhoz1);
imapartz1 = imapartz1*i;

%realpartz1 = linspace(rz1,rz1b,ninterp);
%imapartz1 = linspace(iz1*i,iz1b*i,ninterp);

[thetaz2,rhoz2] = cart2pol(rz2,iz2);

[thetaz2b,rhoz2b] = cart2pol(rz2b,iz2b);

interpthetaz2  = linspace(thetaz2,thetaz2b,ninterp);
interprhoz2   = linspace(rhoz2,rhoz2b,ninterp);


[realpartz2,imapartz2] = pol2cart(interpthetaz2,interprhoz2);
imapartz2 = imapartz2*i;

%realpartz2 = linspace(rz2,rz2b,ninterp);
%imapartz2 = linspace(iz2*i,iz2b*i,ninterp);

[thetaz3,rhoz3] = cart2pol(rz3,iz3);

[thetaz3b,rhoz3b] = cart2pol(rz3b,iz3b);

interpthetaz3  = linspace(thetaz3,thetaz3b,ninterp);
interprhoz3    = linspace(rhoz3,rhoz3b,ninterp);


[realpartz3,imapartz3] = pol2cart(interpthetaz3,interprhoz3);
imapartz3 = imapartz3*i;

%realpartz3 = linspace(rz3,rz3b,ninterp);
%imapartz3 = linspace(iz3*i,iz3b*i,ninterp);
%................................................................

zero1 = realpartz1+imapartz1;
conjuz1=  realpartz1-imapartz1;

b1= -(zero1+conjuz1);
b2= (zero1.*conjuz1);

b0= ones(size(b2)); %after a2 for intialization



zero2 = realpartz2+imapartz2;
conjuz2=  realpartz2-imapartz2;

b12= -(zero2+conjuz2);%-real-real; 

b22= (zero2.*conjuz2);

b02= ones(size(b22)); %after a2 for intialization

coeffb2 =[b02;b12;b22]'; 


%try add linspace to 'real' variable
zero3 = realpartz3+imapartz3;
conjuz3=  realpartz3-imapartz3;

b13= -(zero3+conjuz3);%-real-real; 

b23= (zero3.*conjuz3);

b03= ones(size(b23)); %after a2 for intialization

coeffb3 =[b03;b13;b23]'; 

b1z12 = (b0.*b12)+(b1.*b02);

b2z12 = (b0.*b22)+(b1.*b12)+(b2.*b02);

b3z12 = (b1.*b22)+(b2.*b12);

b4z12 = (b2.*b22);

b0z12 =ones(size(b2z12));

b1tot = (b0z12.*b13)+(b1z12.*b03);

b2tot = (b0z12.*b23)+(b1z12.*b13)+(b2z12.*b03);

b3tot = (b1z12.*b23)+(b2z12.*b13)+(b3z12.*b03);

b4tot = (b4z12.*b03)+(b3z12.*b13)+(b2z12.*b23);

b5tot = (b4z12.*b13)+(b3z12.*b23);

b6tot = (b4z12.*b23);

b0tot =ones(size(b2tot));
coeffbz12 = [b0z12;b1z12;b2z12;b3z12;b4z12]';
coeffbtot = [b0tot;b1tot;b2tot;b3tot;b4tot;b5tot;b6tot]';
%Pole  input values section......................................
%p1

[thetap1,rhop1] = cart2pol(rp1,ip1);

[thetap1b,rhop1b] = cart2pol(rp1b,ip1b);

interpthetap1  = linspace(thetap1,thetap1b,ninterp);
interprhop1    = linspace(rhop1,rhop1b,ninterp);


[realpart1,imapart1] = pol2cart(interpthetap1,interprhop1);
imapart1 = imapart1*i;

%realpart1 = linspace(rp1,rp1b,ninterp);
%imapart1 = linspace(ip1*i,ip1b*i,ninterp);
%p2
[thetap2,rhop2] = cart2pol(rp2,ip2);

[thetap2b,rhop2b] = cart2pol(rp2b,ip2b);

interpthetap2  = linspace(thetap2,thetap2b,ninterp);
interprhop2    = linspace(rhop2,rhop2b,ninterp);


[realpart2,imapart2] = pol2cart(interpthetap2,interprhop2);
imapart2 = imapart2*i;

%realpart2 = linspace(rp2,rp2b,ninterp);
%imapart2 = linspace(ip2*i,ip2b*i,ninterp);
%p3

[thetap3,rhop3] = cart2pol(rp3,ip3);

[thetap3b,rhop3b] = cart2pol(rp3b,ip3b);

interpthetap3  = linspace(thetap3,thetap3b,ninterp);
interprhop3    = linspace(rhop3,rhop3b,ninterp);


[realpart3,imapart3] = pol2cart(interpthetap3,interprhop3);
imapart3 = imapart3*i;

%realpart3 = linspace(rp3,rp3b,ninterp);
%imapart3 = linspace(ip3*i,ip3b*i,ninterp);
%p4
[thetap4,rhop4] = cart2pol(rp4,ip4);

[thetap4b,rhop4b] = cart2pol(rp4b,ip4b);

interpthetap4  = linspace(thetap4,thetap4b,ninterp);
interprhop4    = linspace(rhop4,rhop4b,ninterp);


[realpart4,imapart4] = pol2cart(interpthetap4,interprhop4);
imapart4 = imapart4*i;

%realpart4 = linspace(rp4,rp4b,ninterp);
%imapart4 = linspace(ip4*i,ip4b*i,ninterp);
%p5
[thetap5,rhop5] = cart2pol(rp5,ip5);

[thetap5b,rhop5b] = cart2pol(rp5b,ip5b);

interpthetap5 = linspace(thetap5,thetap5b,ninterp);
interprhop5    = linspace(rhop5,rhop5b,ninterp);


[realpart5,imapart5] = pol2cart(interpthetap5,interprhop5);
imapart5 = imapart5*i;

%realpart5 = linspace(rp5,rp5b,ninterp);
%imapart5 = linspace(ip5*i,ip5b*i,ninterp);
%................................................................   
else
%Zeros  input values section......................................
realpartz1 = linspace(rz1,rz1b,ninterp);
imapartz1 = linspace(iz1*i,iz1b*i,ninterp);

realpartz2 = linspace(rz2,rz2b,ninterp);
imapartz2 = linspace(iz2*i,iz2b*i,ninterp);

realpartz3 = linspace(rz3,rz3b,ninterp);
imapartz3 = linspace(iz3*i,iz3b*i,ninterp);
%................................................................
%try add linspace to 'real' variable
zero1 = realpartz1+imapartz1;
conjuz1=  realpartz1-imapartz1;

b1= -(zero1+conjuz1);
b2= (zero1.*conjuz1);

b0= ones(size(b2)); %after a2 for intialization


%try add linspace to 'real' variable
zero2 = realpartz2+imapartz2;
conjuz2=  realpartz2-imapartz2;

b12= -(zero2+conjuz2);%-real-real; 

b22= (zero2.*conjuz2);

b02= ones(size(b22)); %after a2 for intialization

coeffb2 =[b02;b12;b22]'; %it uses ; to create multiple rows and ' to rotate
%the matrix for easier comparison


%try add linspace to 'real' variable
zero3 = realpartz3+imapartz3;
conjuz3=  realpartz3-imapartz3;

b13= -(zero3+conjuz3);%-real-real; 

b23= (zero3.*conjuz3);

b03= ones(size(b23)); %after a2 for intialization

coeffb3 =[b03;b13;b23]'; %it uses ; to create multiple rows and ' to rotate
%the matrix for easier comparison
%calculates coefficients first two poles
b1z12 = (b0.*b12)+(b1.*b02);

b2z12 = (b0.*b22)+(b1.*b12)+(b2.*b02);

b3z12 = (b1.*b22)+(b2.*b12);

b4z12 = (b2.*b22);

b0z12 =ones(size(b2z12));

b1tot = (b0z12.*b13)+(b1z12.*b03);

b2tot = (b0z12.*b23)+(b1z12.*b13)+(b2z12.*b03);

b3tot = (b1z12.*b23)+(b2z12.*b13)+(b3z12.*b03);

b4tot = (b4z12.*b03)+(b3z12.*b13)+(b2z12.*b23);

b5tot = (b4z12.*b13)+(b3z12.*b23);

b6tot = (b4z12.*b23);

b0tot =ones(size(b2tot));
coeffbz12 = [b0z12;b1z12;b2z12;b3z12;b4z12]';
coeffbtot = [b0tot;b1tot;b2tot;b3tot;b4tot;b5tot;b6tot]';
%Pole  input values section......................................
%p1
realpart1 = linspace(rp1,rp1b,ninterp);
imapart1 = linspace(ip1*i,ip1b*i,ninterp);
%p2
realpart2 = linspace(rp2,rp2b,ninterp);
imapart2 = linspace(ip2*i,ip2b*i,ninterp);
%p3
realpart3 = linspace(rp3,rp3b,ninterp);
imapart3 = linspace(ip3*i,ip3b*i,ninterp);
%p4
realpart4 = linspace(rp4,rp4b,ninterp);
imapart4 = linspace(ip4*i,ip4b*i,ninterp);
%p5
realpart5 = linspace(rp5,rp5b,ninterp);
imapart5 = linspace(ip5*i,ip5b*i,ninterp);
end
%................................................................
%try add linspace to 'real' variable
%p1 conj
pole1 = realpart1+imapart1;
conju1=  realpart1-imapart1;

a1= -(pole1+conju1);
a2= (pole1.*conju1);

a0= ones(size(a2)); %after a2 for intialization

%p2 conj

pole2 = realpart2+imapart2;
conju2=  realpart2-imapart2;

a12= -(pole2+conju2);%-real-real; 

a22= (pole2.*conju2);

a02= ones(size(a22)); %after a2 for intialization

coeffa2 =[a02;a12;a22]'; 


%p3 conj
pole3 = realpart3+imapart3;
conju3=  realpart3-imapart3;

a13= -(pole3+conju3);%-real-real; 

a23= (pole3.*conju3);

a03= ones(size(a23)); %after a2 for intialization

coeffa3 =[a03;a13;a23]'; 

%p4 conj
pole4 = realpart4+imapart4;
conju4=  realpart4-imapart4;

a14= -(pole4+conju4);%-real-real; 

a24= (pole4.*conju4);

a04= ones(size(a24)); %after a2 for intialization

coeffa4 =[a04;a14;a24]';


%p4 conj
pole5 = realpart5+imapart5;
conju5=  realpart5-imapart5;

a15= -(pole5+conju5);%-real-real; 

a25= (pole5.*conju5);

a05= ones(size(a25)); %after a2 for intialization

coeffa5 =[a05;a15;a25]';


%---------------------------------------
%P1*P2
%calculates coefficients first two poles
a1p12 = (a0.*a12)+(a1.*a02);

a2p12 = (a0.*a22)+(a1.*a12)+(a2.*a02);

a3p12 = (a1.*a22)+(a2.*a12);

a4p12 = (a2.*a22);

a0p12 =ones(size(a2p12));
%P1*P2*P3
%adding third pole
a1p123 = (a0p12.*a13)+(a1p12.*a03);

a2p123 = (a0p12.*a23)+(a1p12.*a13)+(a2p12.*a03);

a3p123 = (a1p12.*a23)+(a2p12.*a13)+(a3p12.*a03);

a4p123 = (a4p12.*a03)+(a3p12.*a13)+(a2p12.*a23);

a5p123 = (a4p12.*a13)+(a3p12.*a23);

a6p123 = (a4p12.*a23);

a0p123 =ones(size(a1p123));

%P1*P2*P3*P4
%adding fourth pole
a1p1234  = (a1p123.*a04)+(a0p123.*a14);

a2p1234  = (a0p123.*a24)+(a1p123.*a14)+(a2p123.*a04);

a3p1234  = (a1p123.*a24)+(a2p123.*a14)+(a3p123.*a04);

a4p1234 = (a2p123.*a24)+(a3p123.*a14)+(a4p123.*a04);

a5p1234  = (a3p123.*a24)+(a4p123.*a14)+(a5p123.*a04);

a6p1234  = (a4p123.*a24)+(a5p123.*a14)+(a6p123.*a04);

a7p1234  = (a5p123.*a24)+(a6p123.*a14);

a8p1234  = (a6p123.*a24);

a0p1234  =ones(size(a2p1234));

%P1*P2*P3*P4*P5
a1ptot   = (a0p1234.*a15)+(a1p1234.*a05);
a2ptot   = (a0p1234.*a25)+(a1p1234.*a15)+(a2p1234.*a05);
a3ptot   = (a1p1234.*a25)+(a2p1234.*a15)+(a3p1234.*a05);
a4ptot   = (a2p1234.*a25)+(a3p1234.*a15)+(a4p1234.*a05);
a5ptot   = (a3p1234.*a25)+(a4p1234.*a15)+(a5p1234.*a05);
a6ptot   = (a4p1234.*a25)+(a5p1234.*a15)+(a6p1234.*a05);
a7ptot   = (a5p1234.*a25)+(a6p1234.*a15)+(a7p1234.*a05);
a8ptot   = (a6p1234.*a25)+(a7p1234.*a15)+(a8p1234.*a05);
a9ptot   = (a7p1234.*a25)+(a8p1234.*a15);
a10ptot  = (a8p1234.*a25);
a0ptot   = ones(size(a2ptot));


coeffap12 = [a0p12;a1p12;a2p12;a3p12;a4p12]';
coeffap123 = [a0p123;a1p123;a2p123;a3p123;a4p123;a5p123;a6p123]';
coeffap1234 = [a0p1234;a1p1234;a2p1234;a3p1234;a4p1234;a5p1234;a6p1234;...
    a7p1234;a8p1234]';

coeffaptot = [a0ptot;a1ptot;a2ptot;a3ptot;a4ptot;a5ptot;a6ptot;a7ptot;...
    a8ptot;a9ptot;a10ptot]';

figure(3)
  for n = 1:ninterp
 zplane(coeffbtot(n,:),coeffaptot(n,:));
 pause(0.00012)  
  end
  
  %%%%%%%%%%%%%framing system

if windowsynthesis==2
for j=1:nframes
    k = (framelen-hopsize)*j;
    
   frame  = filter(coeffbtot(j,:)',coeffaptot(j,:)',sig(k:k+framelen-1)); 

    out(k:k+framelen-1)=out(k:k+framelen-1)+frame.*w;
    
end
gainnoclip = 0.9;

norm_out = out/max(abs(out)).*gainnoclip;
pause(0.6)
soundsc(norm_out,Fs)    
else
 for j=1:nframes
    k = (framelen-hopsize)*j;




[frame,zf] = filter(coeffbtot(j,:)',coeffaptot(j,:)',sig(k:k+hop-1),zi(j,:));
 zi(j+1,:)= zf;  

monitor(j,:)= k;

stablec(j,:)= isstable(coeffbtot(j,:)',coeffaptot(j,:)');   

    out(k:k+hop-1)=out(k:k+hop-1)+(frame.*wrect);
    
end
gainnoclip = 0.9;

norm_out = out/max(abs(out)).*gainnoclip;
pause(0.6)
soundsc(norm_out,Fs)
end
end
